#!/usr/bin/env python

# xlwtはxlsファイルの書き込みを行うライブラリ。
# xlsxファイルはサポートされていない。

import xlwt

# Workbookオブジェクトを作成しadd_sheet()メソッドでワークシートを追加、
# Worksheetオブジェクトのwrite()メソッドでセルに値を入力していくイメージ。
# xlwt.Workbook()でWorkbookオブジェクトを作成。

wb = xlwt.Workbook()

#print(type(wb))
# <class 'xlwt.Workbook.Workbook'>


#add_sheet()メソッドでワークシートを追加。Worksheetオブジェクトが返る。
#既存のシート名を指定するとエラーになるので注意。

#sheet = wb.add_sheet('sheet1')

#print(type(sheet))
# <class 'xlwt.Worksheet.Worksheet'>


#Worksheetオブジェクトのwrite()メソッドで値を入力。
#第一引数が行番号、第二引数が列番号、第三引数が入力する値。行番号、列番号は0始まり。
#sheet.write(0, 0, 'A')
#sheet.write(0, 1, 'B')
#sheet.write(1, 0, 10)
#sheet.write(1, 1, 20)


#Worksheetオブジェクトのsave()メソッドにパスを指定するとファイルとして保存される。
#既存のファイルのパスを指定すると上書きされる（元のファイルのデータは削除される）ので注意。

#wb.save('xlwt_sample.xls')


#以下のような関数を定義すると、2次元配列（リストのリスト）を書き込むことができる。
#引数start_row, start_colに2次元配列が書き込まれる行番号と列番号を0始まりで指定する。

sheet2 = wb.add_sheet('sheet2')

def write_list_1d(sheet, l, start_row, start_col):
    for i, val in enumerate(l):
        sheet.write(start_row, start_col + i, val)

def write_list_2d(sheet, l_2d, start_row, start_col):
    for i, l in enumerate(l_2d):
        write_list_1d(sheet, l, start_row + i, start_col)

l_2d = [['A', 'B', 'C'], [1, 2, 3]]
write_list_2d(sheet2, l_2d, 1, 2)
#write_list_2d(sheet2, l_2d, 5, 2)

wb.save('xlwt_sample2.xls')

